#!/usr/bin/perl
##############################################################################
# Functional Description:
# -----------------------
#
# This script is called by phonelogger.pl and do the actual DTMF decoding and 
# MP3 conversion
# You should adapt this to your own needs
# Autor: Walter Leemput 12/12/2003
##############################################################################
#     
#MP3 tagger modifier 
use MP3::Info;

#Perl interface to MYSQL
use DBI;             

#perl audiomixer
use Audio::Mixer;

my $file;
my $mp3;
my $caller_id;
my @fields;
my $dbh;
my $localnumber;
my $savenumber;
my $field1_sav;

#callerid SQL database name
$parms{DB_name}='homecontrol';
 
#hostname where the SQL server is running
$parms{sql_server}='linux2.local';
 
#username SQL server
$parms{sql_user}='user';
 
#password SQL server
$parms{sql_password}='yourSQLpaswd';   

#file for outgoing call list used by webinterface
$parms{outgoinglist}='/root/mh/data/outgoing_calls.dat';   

###############################
#main program

#connect to SQL database
&connect_sql;     

$header_info = $ARGV[0];
chomp $header_info;
print "$header_info\n";

@fields = split /-/, $header_info;
print "@fields\n";
print "This is the call_status: $fields[15]\n";

  if ($fields[15] eq 'Uitgaand') {

  #process outgoing calls
  print "Analyzing $header_info for DTMF tones\n";
  $dtmf_info=`./multimon -a DTMF -t wav $header_info`;  
  chomp $dtmf_info; 
 
  print "received DTMF: $dtmf_info\n";
  $header_info_sav = $header_info;
    if ($dtmf_info) {
    $header_info_sav =~ s/DTMF/$dtmf_info/g;
    }    
    else {
    $header_info_sav =~ s/DTMF/Unknown/g;
    }
 
  $header_info_sav =~ s/DTMF/$dtmf_info/g;
  #rename recorded file with the file info
  system ("/bin/mv $header_info $header_info_sav"); 
  system ("/usr/local/bin/lame $header_info_sav $header_info_sav.mp3");   
  system ("/bin/rm $header_info_sav"); 

  @fields = split /-/, $header_info_sav;
  print "@fields\n";

    #translate CLIP to name via SQL search
    if ($fields[16] =~ /Unknown/) {
    $caller_id = "No Number Info";
    $fields[16] = '';
    }

    else {
    #check first if this is a local call which is found in the SQL database (6 digit)
    #this assumes that there is no missing first digit as can happen sometimes
    #dont check the netnumber in this stage
    $savenumber = $fields[16];
    $localnumber=(substr($fields[16],0,6));
    $caller_id = (&get_displayname("$localnumber","0"));
      if ($caller_id) {
      #if local number found then add Rijen (local) netnumber
      $fields[16]=("0161".$localnumber);
      }
      else {   
        #due delay it sometimes happens that the first DTMF is not recorded, this is always a 0
        if ((substr($fields[16],0,1)) ne '0') {
        $fields[16]=("0".$fields[16]);
        }                                    
      $fields[16]=(substr($fields[16],0,14));
      #get only the called name
      $caller_id = (&get_displayname("$fields[16]","0"));
        if (!$caller_id) {
        $fields[16]=(substr($fields[16],0,13));
        #get only the called name
        $caller_id = (&get_displayname("$fields[16]","0"));  
          if (!$caller_id) {
          $fields[16]=(substr($fields[16],0,12));
          #get only the called name
          $caller_id = (&get_displayname("$fields[16]","0"));
            if (!$caller_id) {
            $fields[16]=(substr($fields[16],0,11));
            #get only the called name
            $caller_id = (&get_displayname("$fields[16]","0"));
              if (!$caller_id) {
              $fields[16]=(substr($fields[16],0,10));
              #get only the called name
              $caller_id = (&get_displayname("$fields[16]","0"));
                if (!$caller_id) {
                #get the called name or eventually netnumber
                $caller_id = (&get_displayname("$fields[16]","1"));
                $fields[16] = $savenumber;
                }
              }
            }
          }
        }
      }
    }  

  #write MP3 tags with callername and number and date/time info
  $mp3 = new MP3::Info "$header_info_sav.mp3";
  $mp3->artist("$caller_id $fields[16]");
  #make it beautiful
  $field1_sav = $fields[1]; #save this for webinterface format
  $fields[1] = "0$fields[1]" if (length($fields[1]) == 1); 
  $fields[3] = "0$fields[2]" if (length($fields[2]) == 1); 
  $fields[4] = "0$fields[4]" if (length($fields[4]) == 1); 
  $fields[5] = "0$fields[5]" if (length($fields[5]) == 1); 
  $fields[6] = "0$fields[6]" if (length($fields[6]) == 1); 
  $mp3->title("$fields[15] $fields[1]-$fields[2]-$fields[3] $fields[4]\:$fields[5]\:$fields[6]"); 

  #make outgoing call file for IA5 webinterface
  #open the outgoing call file
  open(outgoinglist, ">>$parms{outgoinglist}") || print("Could not open file: $!\n"); 
  #write info to file

  $fields[7] = "Su" if ($fields[7] == 0);
  $fields[7] = "Ma" if ($fields[7] == 1);
  $fields[7] = "Tu" if ($fields[7] == 2);
  $fields[7] = "We" if ($fields[7] == 3);
  $fields[7] = "Th" if ($fields[7] == 4);
  $fields[7] = "Fr" if ($fields[7] == 5);
  $fields[7] = "Sa" if ($fields[7] == 6);

  $fields[2] = "Jan" if ($fields[2] eq '01');
  $fields[2] = "Feb" if ($fields[2] eq '02');
  $fields[2] = "Mar" if ($fields[2] eq '03');
  $fields[2] = "Apr" if ($fields[2] eq '04');
  $fields[2] = "May" if ($fields[2] eq '05');
  $fields[2] = "Jun" if ($fields[2] eq '06');
  $fields[2] = "Jul" if ($fields[2] eq '07');
  $fields[2] = "Aug" if ($fields[2] eq '08');
  $fields[2] = "Sep" if ($fields[2] eq '09');
  $fields[2] = "Oct" if ($fields[2] eq '10');
  $fields[2] = "Nov" if ($fields[2] eq '11');
  $fields[2] = "Dec" if ($fields[2] eq '12');

  print (outgoinglist "$fields[7] $field1_sav $fields[2] $fields[4]\:$fields[5] $caller_id $fields[16]\n");
  #close the outgoing call file
  close(outgoinglist);    

  } 
  else {
  #process incoming calls
  system ("/usr/local/bin/lame $header_info $header_info.mp3");   
  system ("/bin/rm $header_info"); 
  @fields = split /-/, $header_info;
  print "@fields\n";
  $mp3 = new MP3::Info "$header_info.mp3";
  
    #translate CLIP in name via SQL search
    if ($fields[16] =~ /Unknown/) {
    $caller_id = "No Number Info";
    $fields[16] = '';  
    }
    else {
    #get the callername and eventually the netnumber
    $caller_id = (&get_displayname("$fields[16]","1"));
    }    

  #make it beautifull
  $fields[1] = "0$fields[1]" if (length($fields[1]) == 1);
  $fields[2] = "0$fields[2]" if (length($fields[3]) == 1);
  $fields[4] = "0$fields[4]" if (length($fields[4]) == 1);
  $fields[5] = "0$fields[5]" if (length($fields[5]) == 1);
  $fields[6] = "0$fields[6]" if (length($fields[6]) == 1);   
  $mp3->artist("$caller_id $fields[16]");
  $mp3->title("$fields[15] $fields[1]-$fields[2]-$fields[3] $fields[4]\:$fields[5]\:$fields[6]"); 
  }

prepare mixer for playing the phonecall
&set_mixer;
 
#sort the calls on date and start xmms player
system ("cd /root/misterhouse/prompts/phone; ls --sort=time > /tmp/phone_mon.dat; /usr/X11/bin/xmms `cat /tmp/phone_mon.dat`");

#disconnect from SQL database
$dbh->disconnect;
exit 1;               


#sub routine section
##############################
# connect to the SQL database
##############################
sub connect_sql {
    print "Connecting to $parms{DB_name} SQL database\n";
    $dbh = DBI->connect("DBI:mysql:dbname=$parms{DB_name};host=$parms{sql_server}", "$parms{sql_user}", "$parms{sql_password}") or die "Couldn't connect to database: ". DBI::errstr;
    }               

###########################################################
# SQL database query for displayname
# if $givenetnumber = true then search for netnumbers also
###########################################################
sub get_displayname {
    my($telno, $givenetnumber) = @_;
    my $callername;
    my $output;
    my $netnumber;
 
    my $search=$dbh->prepare("SELECT * FROM callerid
    WHERE fixtelno1 = '$telno' or fixtelno2 = '$telno' or fixtelno3 = '$telno' or mobtelno1 = '$telno' or mobtelno2  = '$telno' or mobtelno3 = '$telno'");
    $search->execute;
    $callername=$search->fetchrow_hashref;
      if ($callername->{dispname}) {
      $output = $callername->{dispname};
      print "found dispname: $output\n";
      return $output;
      }
      elsif ($givenetnumber) {
      $netnumber = (substr($telno, 0, 4));
      my $search=$dbh->prepare("SELECT * FROM netnumbertab
      WHERE netnumber = '$netnumber'");
      $search->execute;
      $callername=$search->fetchrow_hashref;
 
        if ($callername->{netname}) {
        $output = $callername->{netname};  
        print "found dispname: Region $output\n";
        return "Regio $output";
        }
        else {
        $netnumber = (substr($telno, 0, 3));
        my $search=$dbh->prepare("SELECT * FROM netnumbertab
        WHERE netnumber = '$netnumber'");
        $search->execute;
        $callername=$search->fetchrow_hashref;
 
          if ($callername->{netname}) {
          $output = $callername->{netname};
          print "found dispname: Region $output\n";
          return "Region $output";
          }
          else {
          $netnumber = (substr($telno, 0, 2));
          my $search=$dbh->prepare("SELECT * FROM netnumbertab
          WHERE netnumber = '$netnumber'");
          $search->execute;
          $callername=$search->fetchrow_hashref;

            if ($callername->{netname}) {
            $output = $callername->{netname};
            print "found dispname: Region $output\n";
            return "Region $output";
            }
            else {
            return "Onbekend";
            }
          }
        }
      }
    }           

############
# set mixer
############
sub set_mixer {
    Audio::Mixer::set_cval('pcm', 50);
    Audio::Mixer::set_cval('vol', 70); #master volume
    Audio::Mixer::set_cval('bass', 50);
    Audio::Mixer::set_cval('treble', 50);
    Audio::Mixer::set_cval('synth', 50);
    Audio::Mixer::set_cval('ogain', 0);
    Audio::Mixer::set_cval('igain', 0);
    Audio::Mixer::set_cval('mix', 100);
    Audio::Mixer::set_cval('mic', 70);
    Audio::Mixer::set_cval('line', 0);
    Audio::Mixer::set_cval('speaker', 0);
    Audio::Mixer::set_cval('cd', 0);
    Audio::Mixer::set_cval('synth', 0);
    }      
