#!/usr/bin/perl

=begin comment

phonelogger.pl: Telephone logging system by Walter Leemput 12/12/2003

Purpose:
-Logging from Incoming/Outgoing telephone callername/number
-Recording from incoming/outgoing telephone calls
-Playing recorded Phonecalls on ordinary MP3 player with callername/number in MP3 tag info   
 
Hardware requirements:
-PC
-Any soundcard working on Linux 
-Telephone to Mic-input interface
-I/O card for detecting telephone ON/OFF hook status or other methods

Software requirements:
-an_recording.pl (wil do the actual DTMF decoding on background) is included 
-Linux distribution (Could be working on Windows but need many adaptions)
-CPAN perl modules (http://cpan.org)
 MP3::Info;
 DBI 
 Audio::Mixer 
-Commandline Sound-recorder by B. Warmerdam (Could be any commandline wav recorder but i included this one)
-MP3 player for example XMMS (http://www.xmms.org)
-Multimon DTMF decoder on (http://www.baycom.org/~tom/ham/linux/multimon.html) The most important piece of software. Believe it or not but this is the only one i found running under Linux after 3 hours Google. But it works great,Thanks to the autor. I included the multimon binary i compiled myself with some modification as i needed only a DTMF string and nothing more. Never run this on the commandprompt without any options, this will lock up your computer. Use the options i gave in my script. 
-Mysql, only needed when called/caller name is required (http://www.mysql.com)

Description:
I didn't want to purchase special DTMF decode hardware as a software solution is 
cheaper and more flexible. The maingoal was to make it work on a ordinary soundcard and do the DTMF decoding stuff with special software. 
Dont expect a working out of the box program, you have to modify this for your own needs. 
Take care of the file paths i have used, you have to adapt this also.
For me its working very well but you have to implement this in your own environment. 
 
In a nutshell this is how it works:
The Telephone to mic-input is connected to the Mic-input from the soundcard.
I have a PC I/O card which will detect a telephone OFFHOOK by taking a 
relay from my PABX which can be done in several other ways. The only important thing is to have a signal which detects ON/OFF hook from your telephone. This could be solved in various ways and i don't want to go into this.

I'm using the excellent program Misterhouse as the main program. I wrote MH code for the most of the common automation tasks in my house. I also wrote external modules like a IVR, answermachine, GUI and this Telephone logging system which communicates via the MH socket method. This is done as the modules have to exchange information to MH and back.
The Telephone logging module is also written in Perl.
I will describe a callcase from a telephone call: 
 
-Telephone goes OFFHOOK
-Perl Audiomixer will set the mic-input level from the soundcard (DTMF decoding wil only work when the level is ok and is not distorted, you have to experiment with this but you can use the level meter in most GUI audiomixers to check the recording level)
-A commandline soundrecorder is started in the background en records the telephone call into a wav-file (You have to sample with 22Khz else DTMF decoding doesn't work so keep the default options in this program.
-Starttime is copied into the filename of the wavfile.
-Detecting if this is a incoming or outgoing call. If its a incoming call then the callerid is taken via the MH socket (Callerid modem within the MH program) You dont have to create any socket with the MH program but for me its handy to check if this is a incoming or outgoing call as the info is already available within MH. 
-Telephone goes ONHOOK
-Recording is stopped by sending a kill signal to the soundrecorder.
-Callerid is copied in the filename from the recorded WAV file if it was a incoming call.
-A new script is started in the background which is doing the most tricky part, DTMF decoding. In this script the C program from Thomas Sailer "multimon" is called only when it was a outgoing call. This program is used by radioamateurs but its working great for our purpose, DTMF decoding. I modified the program to output only the callerid and nothing more.
-Multimon will analyse the recorded WAV file and will produce a string with the called telephonenumber.
-The called number string is searched in a MYSQL database. If it finds something it will present a callername else it will try to find with the netnumber the city. (If you dont want or have a SQL database you dont have to do this but its very handy else you only will have the telephone numbers and not the names. Ofcourse you can make also use of the standard callerid code which is in the MH distribution)
-The WAV file is converted to MP3 format with the program "lame", 
This is done for saving diskspace and the MP3 tags possibility. (also other wav->MP3 converters will work but this is the most populair one)
-Then the callername, number and start and stoptime is saved in the MP3 
tags with the CPAN module MP3::Info (very handy as the caller/called name, number and start/stoptime is written to the MP3 tags. With this the MP3 file is complete with all relevant recording information. 
-A playlist is generated on date sequence. Also a incoming and outgoing 
call list is updated so i can go to the MH IA5 webinterface to see 
incoming and outgoing calls with there names and numbers and time.
-Then its easy, just run xmms with the playlist and then you will see 
the callername, callernumber, incoming or outgoing call and the stop and 
starttime. You will also hear the conversation.

=cut

####################
# used perl modules
####################             
require 5.000;
use Audio::Mixer;
 
########################
# configuration section
########################
#
#system base directory
$parms{base_dir}='/root'; 

#hostname from the PIO remote socket server
$parms{host}='linux2.local';
 
#connect port number PIO remote socket server
$parms{port}='1239';

################
# start program
################
#
#connect to PIO server socket
#This is for getting the call status (incoming or outgoing)
#You dont have to do this but its only an example
&create_pio_socket;  

###############
# main program
###############
my $tel_status;
my $start_time;
my $stop_time;

  #remove tmp wav file else sound-recorder dies
  if (-e "/tmp/record.wav") {     
  print "removing /tmp/record.wav\n"; 
  system ("/bin/rm /tmp/record.wav");
  }

  while (1==1) { #make it a continu loop

        #i toke away my code which gives me the ON/OFF hook status, it could be confusing
        #You have to add your specific code in here to poll the ON/OFF hook detection.
        if (digital input = OFFHOOK status) {

        #xmms should not running else /dev/dsp is occupied
        #kill to be sure
        system ("/usr/bin/killall xmms");  

        #start recording telephone call when OFFHOOK
        #use the included soundrecorder but could be any wav recorder, take care of the samplerate 
        #should be 22050 else DTMF decoding will not work, 8 bits is enough
        system ("./sound-recorder -f wav -P -b 8 -s 22050 -c 1 /root/misterhouse/tmp/record.wav &");

        #set recording level, not to much gain else distorsion, again no DTMF decoding then 
        &set_mixer;
               
        #get starttime recording        
        my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
        $year=$year+1900;
        $mon=$mon+1;
        $start_time = "$mday-$mon-$year-$hour-$min-$sec-$wday";      
 
        #get telephone status if outgoing or incoming call
        #you can do this with your own method, this is my one 
        $tel_status=(&send_pio_socket ("get_phone_status"));
        chomp $tel_status;
        print "$tel_status received from MH server\n"; 
        }
        else {

        #put here the ONHOOK code
        #put your own code here to poll the ON/OFF hook detection.

        #stop recording telephone call when ONHOOK 
        #just kill the soundrecorder 
        print "Stop recording\n"; 
        &stop_record;  

        #get stoptime recording        
        my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
        $year=$year+1900;
        $mon=$mon+1;
        $stop_time = "$mday-$mon-$year-$hour-$min-$sec-$wday";

          if ($tel_status eq 'Uitgaand') {
          $file_name = "/tmp/record-$start_time-$stop_time-$tel_status-DTMF-.wav"; 
          }
          else {
          $file_name = "/tmp/record-$start_time-$stop_time-Inkomend-$tel_status-.wav";          
          }
        print "filename: $file_name\n"; 

        #rename recorded file with the file info
        system ("/bin/mv /root/misterhouse/tmp/record.wav $file_name"); 

        #analyze recording on the background with included an_recording.pl
        #because the next call can be processed while the DTMF decoding and MP3 conversion 
        #its done on the background, else you would miss the next call if the current phonecall is long.
        #This could be if your wife calls her girlfriends..  :-)
        #DTMF decoding is fast but the WAV->MP3 conversion can take some seconds 
        system ("./an_recording.pl $file_name &");

        } 
      }
    }
  #delay from 100ms to avoid high CPU load
  select undef, undef, undef, .1;
  } 	

##################################################
# create client to Misterhouse PIO socket server 
##################################################
sub create_pio_socket {
    use IO::Socket;
    print "Socket created on: $parms{host} port $parms{port}\n";
    $socket = new IO::Socket::INET (PeerAddr => $parms{host}, PeerPort => $parms{port}, Proto => 'tcp') or die "\nCould not create socket: $!\n";
    }

#################################################
# send command to Misterhouse PIO socket server
#################################################
sub send_pio_socket {
    my ($data) = @_;     
    print $socket "$data\n";
    print "data sent to MH server: $data\n";
    my $answer = <$socket>;
    print "response from MH server: $answer";
    return $answer;
    }

############
# set mixer 
############
sub set_mixer { 
    Audio::Mixer::set_cval('pcm', 80);
    Audio::Mixer::set_cval('vol', 00); #master volume
    Audio::Mixer::set_cval('bass', 50);
    Audio::Mixer::set_cval('treble', 50);
    Audio::Mixer::set_cval('synth', 50);
    Audio::Mixer::set_cval('ogain', 0);
    Audio::Mixer::set_cval('igain', 0);
    Audio::Mixer::set_cval('mix', 100);
    Audio::Mixer::set_cval('mic', 70);
    Audio::Mixer::set_cval('line', 0);
    Audio::Mixer::set_cval('speaker', 0);
    Audio::Mixer::set_cval('cd', 0);
    Audio::Mixer::set_cval('synth', 0);
    }

#######################
# stop phone recording
#######################
sub stop_record {
    system ("/usr/bin/killall sound-recorder");
    print "sound recording daemon killed\n";
    }


