
# From Brian Paulson on 2/2002

# Port is the port that your weather station is connected to.  If your
# weather station is connected to the rest of your 1-wire net, you don't
# need to specify a port because mh will use that by default
# The CHIPS are a listing of all of the chips that make up the weather
# station.  You can get this list by looking at the ini.txt file that
# is generated by the Dallas Semiconductor Weather Station software
# I believe that the first 01 chip should be north and then the rest are
# listed in clockwise order
# By the way, I currently have the Weather Station sitting on my floor
# in the home office because I'm waiting for springtime to mount it outside
# As such, I haven't had a chance to verify that the wind direction and
# wind speed are accurate.

$weather = new iButton::Weather( CHIPS => [ qw( 01000002C77C1FFE 01000002C7681465 01000002C77C12B4 
                                                01000002C76CD4E5 01000002C77C1EC9 01000002C76724E7 
                                                01000002C761AF69 01000002C7798A76 1D000000010C46AA 
                                                1200000013571545 10000000364A826A) ] );
#                                PORT => $port );
if ($New_Second) {                                
    if ( $Second == 29) {
        my $temp = $weather->read_temp;
        print "Weather Temp = $temp\n" if defined $temp;
    }
    if ( $Second % 5 == 0 ) {
        my $windspeed = $weather->read_windspeed;
        print "Speed = $windspeed MPH\n" if defined $windspeed;
        
        my $dir = $weather->read_dir;
        print "Direction = $dir\n" if defined $dir;
    }
}
       
